35c4893f7438c5231e3e8f6635691354cbbac83f
[BK-2020-03.git] / unitproc / bktemp-timeUntilNextDay
1 #!/bin/bash
2 # Desc: Template to report seconds until beginning of next day
3
4 #==BEGIN Define script parameters==
5 #===BEGIN Declare local script functions===
6 yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
7 die() { yell "$*"; exit 111; }
8 try() { "$@" || die "cannot $*"; }
9 timeUntilNextDay(){
10 # Desc: Report seconds until next day.
11 # Version: 1.0.0
12 # Output: stdout: integer seconds until next day
13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
14 # Usage: timeUntilNextDay
15 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
16 # Depends: date 8, echo 8, yell, try
17
18 local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
19
20 TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
21 TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
22 SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
23 if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
24 returnState="true";
25 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
26 returnState="warning_zero";
27 yell "WARNING:Reported time until next day exactly zero.";
28 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
29 returnState="warning_negative";
30 yell "WARNING:Reported time until next day is negative.";
31 fi
32
33 try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
34
35 # Determine function return code
36 if [[ "$returnState" = "true" ]]; then
37 return 0;
38 elif [[ "$returnState" = "warning_zero" ]]; then
39 return 1;
40 elif [[ "$returnState" = "warning_negative" ]]; then
41 return 2;
42 fi
43 } # Report seconds until next day
44 #===END Declare local script functions===
45 #==END Define script parameters==
46
47
48 #==BEGIN sample code==
49 try echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report
50
51 if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
52 #==END sample code==
53
54 # Author: Steven Baltaktei Sandoval
55 # License: GPLv3+